coclass 'pgraphview'

TITLE=: 'Graph View'
TEMPFILE=: 'graphview'
TEMPDIR=: jpath '~temp'
ADDONDIR=: jpath '~addons/graphviz'
FILTER=: 'Graph File (*.dot)|*.dot|All Files (*.*)|*.*'

require 'files'
require ADDONDIR,'\task.ijs'
0!:0 < ADDONDIR,'\graphviewx.ijs'

graphview_z_=: [: empty conew&'pgraphview'
create=: f_run
destroy=: f_close_button=: f_close
formselect=: 3 : 'wd''psel '',HWND'

f_f1_fkey=: f_help_button
f_f5_fkey=: f_go_button
f_nctrl_fkey=: f_new_button
f_octrl_fkey=: f_open_button

navigate=: 3 : 0
  wd 'olemethod w base navigate *',y.
  if. 'about:'-:6{.y. do. y.=. 'about:' end.
  wd 'set url *',y.
NB.  wd 'setfocus w'
)

TABS=: 'f1';'f2'

F=: 0 : 0
pc f;
menupop "&File";
menu new "&New" "Ctrl+N" "Open new window" "";
menu open "&Open ..." "Ctrl+O" "Load file from disk" "";
menusep;
menu clean "Clean" "" "Erase Temporary Files" "";
menusep;
menu close "&Close" "" "Close the window" "";
menupopz;
menupop "&View";
menu go "&Go" "F5" "Refresh display" "";
menupopz;
menupop "&Help";
menu help "&Contents" "F1" "Display help" "";
menu helplic "License" "" "License" "";
menu helpsm "Sequential Machine Legend" "" "Sequential Machine" "";
menu helpsmlab "Sequential Machine Lab" "" "Sequential Machine" "";
menusep;
menu dotguide "Dot Guide" "" "Dot Guide" "";
menu neatoguide "Neato Guide" "" "Neato Guide" "";
menusep;
menu about "&About" "" "Display program information" "";
menupopz;
sbar 2;
sbarset sbStatus 100 "Ready";
sbarset sbOption 40 "";
sbarshow;
xywh 120 12 320 240;cc w ocx:Shell.Explorer.2 rightmove bottommove;
xywh 0 2 121 250;cc tab tab bottommove;
xywh 120 1 300 10;cc url edit es_autohscroll es_readonly rightmove;
xywh 421 1 18 10;cc go button leftmove rightmove;cn "Go";
xywh 96 3 24 8;cc s1 static;cn "Address";
pas 0 0;pcenter;
rem form end;
)

F1=: 0 : 0
pc f1;
xywh 0 1 117 236;cc src editm ws_hscroll ws_vscroll es_autohscroll es_autovscroll bottommove;
pas 0 0;pcenter;
rem form end;
)

F2=: 0 : 0
pc f2;
xywh 1 6 20 8;cc s2 static;cn "Program";
xywh 24 4 80 220;cc prog combolist;
xywh 105 4 10 10;cc proghelp button;cn "?";
xywh 1 18 50 8;cc s3 static;cn "Output Format";
xywh 1 25 114 220;cc fmt combolist;
xywh 84 16 32 8;cc astext checkbox;cn "As Text";
xywh 2 110 110 2;cc s9 staticbox ss_etchedhorz;
pas 0 0;pcenter;
rem form end;
)

f1_run=: 3 : 0
  wd F1
)

f2_run=: 3 : 0
  wd F2
  astext=: ,'0'
  ndxp=. 'dot' ndx PROGRAMS
  ndxf=. 'png' ndx FORMATS
  PROG=: prog=: selitem >ndxp{<;._2 PROGRAMS
  FMT=: fmt=: selitem >ndxf{<;._2 FORMATS
  wd 'set fmt *',FORMATS
  wd 'setselect fmt ',":ndxf
  wd 'set prog *',PROGRAMS
  wd 'setselect prog ',":ndxp
)

f_run=: 3 : 0
  wd F
  HWND=: wd 'qhwndp'
  wd 'pn *',TITLE

  TABNDX=: 0
  wd 'set tab "Source" "Options"'
  wd 'creategroup tab'
  f1_run''
  f2_run''
  wd 'creategroup'
  wd 'setshow f1 1'

  wd 'settabstops src 10'
  navigate 'about:blank'
  SRCNAME=: ''
  if. LF e.y. do. setshow y. else. load jpath y. end.
  wd 'pshow;'
)

f_close=: 3 : 0
  wd 'pclose'
  codestroy''
)

f_tab_button=: 3 : 0
wd 'setshow ',(>TABNDX{TABS),' 0'
TABNDX=: ".tab_select
wd 'setshow ',(>TABNDX{TABS),' 1'
)

f_new_button=: 3 : 0
  graphview''
)

f_open_button=: 3 : 0
  fname=. wd'mbopen "Open Graph File" "" "" "',FILTER,'" ofn_filemustexist'
  if. *#fname do. load fname end.
)

f_clean_button=: 3 : 0
  r=. ":+/0>.ferase fpaths jpath'~temp/graphview.*'
  wdinfo 'Cleaning ...';'Erased ',r,' temporary file(s)'
)

f_go_button=: 3 : 0
  show src
)

f_about_button=: navigate bind (ADDONDIR,'\about.html')
f_help_button=: navigate bind (ADDONDIR,'\help.html')
f_helplic_button=: navigate bind (ADDONDIR,'\license.html')
f_helpsm_button=: navigate bind (ADDONDIR,'\doc\smlegend.gif')
f_helpsmlab_button=: navigate bind (ADDONDIR,'\doc\seq_lab.pdf')
f_dotguide_button=: navigate bind (ADDONDIR,'\doc\dotguide.pdf')
f_neatoguide_button=: navigate bind (ADDONDIR,'\doc\neatoguide.pdf')

f2_proghelp_button=: 3 : 0
  navigate ADDONDIR,'\doc\dotman.pdf'
)

message=: [: navigate 'about:'&,
error=: [: message 'Error: '&(,^:([ -.@-: #@[ {. ]))
selitem=: {.~ i.&' '
unixpath=: '/'&(I.@('\'&=)@]})
ndx=: 4 : 'x.i.~(#x.)&{.;._2 y.'
so_z_=: [ smoutput
fpaths=: <@({.~ >:@i:&PATHSEP_j_)@:> ,&.> {."1@(1!:0)

setshow=: 3 : 0
  wd 'set src *',y.
  show y.
)

load=: 3 : 0
  if. 0=#y. do. message TITLE return. end.
  if. _1=s=. fread y. do. error 'Reading file ',y. return. end.
  SRCNAME=: y.
  wd 'pn *',TITLE,' - ',SRCNAME
  wd 'set src *',s
  show s
)

show=: 3 : 0
  if. 0=#y. do. error 'Blank input' return. end.
  FMT=: selitem fmt
  ASTEXT=. ('1'-:{.astext)#'.txt'
  fname=. TEMPDIR,'\',TEMPFILE,'.',FMT,ASTEXT
  cmdline=. '-T',FMT,' -o',unixpath fname
  ferase fname
  PROG=: selitem prog
  out=. y. spawn ADDONDIR,'\bin\',PROG,' ',cmdline
  if. *#out do. error out return. end.
  if. 0=fexist fname do. error 'Nothing is generated' return. end.
  navigate fname
)


NB. =========================================================

cocurrent 'base'

0 : 0
g=. graphview ''
NB. navigate__g jpath'~addons\graphviz\test.svg'
)
